/**
 * This file was auto-generated by the Titanium Module SDK helper for Android
 * Appcelerator Titanium Mobile
 * Copyright (c) 2009-2017 by Appcelerator, Inc. All Rights Reserved.
 * Licensed under the terms of the Apache Public License
 * Please see the LICENSE included with this distribution for details.
 *
 */
package ti.kotlin;

import org.appcelerator.kroll.KrollDict
import org.appcelerator.kroll.annotations.Kroll
import org.appcelerator.titanium.TiC
import org.appcelerator.kroll.common.Log
import org.appcelerator.kroll.common.TiConfig
import org.appcelerator.titanium.util.TiConvert
import org.appcelerator.titanium.proxy.TiViewProxy
import org.appcelerator.titanium.view.TiCompositeLayout
import org.appcelerator.titanium.view.TiCompositeLayout.LayoutArrangement
import org.appcelerator.titanium.view.TiUIView

import android.app.Activity

@Kroll.proxy(creatableInModule=TiKotlinModule::class)
class ExampleProxy : TiViewProxy()
{
	companion object {
		// Standard Debugging variables
		val LCAT: String = "ExampleProxy"
		val DBG: Boolean = TiConfig.LOGD
	}

	class ExampleView(proxy: TiViewProxy) : TiUIView(proxy)
	{
		init {
			var arrangement: LayoutArrangement = LayoutArrangement.DEFAULT

			if (proxy.hasProperty(TiC.PROPERTY_LAYOUT)) {
				var layoutProperty: String = TiConvert.toString(proxy.getProperty(TiC.PROPERTY_LAYOUT))
				if (layoutProperty == TiC.LAYOUT_HORIZONTAL) {
					arrangement = LayoutArrangement.HORIZONTAL
				} else if (layoutProperty == TiC.LAYOUT_VERTICAL) {
					arrangement = LayoutArrangement.VERTICAL
				}
			}
			setNativeView(TiCompositeLayout(proxy.getActivity(), arrangement))
		}
	}


	override fun createView(activity: Activity): TiUIView
	{
		var view: TiUIView = ExampleView(this)
		view.getLayoutParams().autoFillsHeight = true
		view.getLayoutParams().autoFillsWidth = true
		return view
	}

	// Handle creation options
	override fun handleCreationDict(options: KrollDict)
	{
		super.handleCreationDict(options)

		if (options.containsKey("message")) {
			Log.i(LCAT, "@@@ Example creation property 'message' set to: " + options.get("message"))
		}
	}

	// Methods
	@Kroll.method
	fun printMessage(message: String)
	{
		Log.i(LCAT, "@@@ Example.printMessage() called: " + message)
	}


	@Kroll.getProperty
	@Kroll.method
	fun getMessage(): String
	{
		return "Hello World from my module"
	}

	@Kroll.setProperty
	@Kroll.method
	fun setMessage(message: String)
	{
		Log.i(LCAT, "@@@ Example.setMessage() called: " + message)
	}
}
